Wt: Wt::Auth::Saml::Process Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::Auth::Saml::Process Class Reference

A SAML authentication process. More...

`#include <Wt/Auth/Saml/Process.h>`

Inheritance diagram for Wt::Auth::Saml::Process:
[legend]

## Public Member Functions
const Service & | service () const
| Returns the SAML service which spawned this process.
const WString & | error () const
| Error information, in case authentication or identification failed.
void | startAuthenticate ()
| Starts an authorization and authentication process.
Signal< Identity > & | authenticated ()
| Authentication signal.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual const std::string | id () const
| Returns the (unique) identifier for this object.
virtual void | setObjectName (const std::string &name)
| Sets an object name.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
| Process (const Service &service)
| Constructor.
Protected Member Functions inherited from Wt::WObject
virtual WStatelessSlot * | getStateless (Method method)
| On-demand stateless slot implementation.

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WObject

## Detailed Description

A SAML authentication process.

The process implements the state machine that is needed to complete a SAML authentication cycle.

## Constructor & Destructor Documentation

## ◆ Process()

Wt::Auth::Saml::Process::Process | ( | const Service & | service | ) |
| explicitprotected

Constructor.

See also
  Service::createProcess()

## Member Function Documentation

## ◆ authenticated()

Signal< Identity > & Wt::Auth::Saml::Process::authenticated | ( |  | ) |

Authentication signal.

This signal indicates the end of an authentication process. If the authentication process was successful, then the parameter is a valid and authentic identity. If the authentication process failed then the identity parameter is invalid, and you can get more information using error().

See also
  startAuthenticate(), Service::getIdentity(), Identity::isValid()

## ◆ error()

const WString & Wt::Auth::Saml::Process::error | ( |  | ) | const

Error information, in case authentication or identification failed.

The error message contains details when the authenticated() signal indicates an invalid identity.

## ◆ service()

const Service & Wt::Auth::Saml::Process::service | ( |  | ) | const

Returns the SAML service which spawned this process.

See also
  Service::createProcess()

## ◆ startAuthenticate()

void Wt::Auth::Saml::Process::startAuthenticate | ( |  | ) |

Starts an authorization and authentication process.

The authentication process ends with the authenticated() signal which signals the obtained identity.

Note
  To be able to use a popup (instead of a page redirect), you should connect this method directly to an event signal, since popup windows are blocked in most web browsers unless they are the direct consequence of an event.